MPD

- Main Page
- Data Structures
- Files

- File List
- Globals

Functions

# src/output_all.h File Reference

`#include <stdbool.h>`
`#include <stddef.h>`

Go to the source code of this file.

## Functions
void | audio_output_all_init (void)
| Global initialization: load audio outputs from the configuration file and initialize them.
void | audio_output_all_finish (void)
| Global finalization: free memory occupied by audio outputs.
unsigned int | audio_output_count (void)
| Returns the total number of audio output devices, including those who are disabled right now.
struct audio_output * | audio_output_get (unsigned i)
| Returns the "i"th audio output device.
struct audio_output * | audio_output_find (const char *name)
| Returns the audio output device with the specified name.
void | audio_output_all_enable_disable (void)
| Checks the "enabled" flag of all audio outputs, and if one has changed, commit the change.
bool | audio_output_all_open (const struct audio_format *audio_format, struct music_buffer *buffer)
| Opens all audio outputs which are not disabled.
void | audio_output_all_close (void)
| Closes all audio outputs.
void | audio_output_all_release (void)
| Closes all audio outputs.
bool | audio_output_all_play (struct music_chunk *chunk)
| Enqueue a music_chunk object for playing, i.e.
unsigned | audio_output_all_check (void)
| Checks if the output devices have drained their music pipe, and returns the consumed music chunks to the #music_buffer.
bool | audio_output_all_wait (unsigned threshold)
| Checks if the size of the #music_pipe is below the #threshold.
void | audio_output_all_pause (void)
| Puts all audio outputs into pause mode.
void | audio_output_all_drain (void)
| Drain all audio outputs.
void | audio_output_all_cancel (void)
| Try to cancel data which may still be in the device's buffers.
void | audio_output_all_song_border (void)
| Indicate that a new song will begin now.
float | audio_output_all_get_elapsed_time (void)
| Returns the "elapsed_time" stamp of the most recently finished chunk.

## Function Documentation

void audio_output_all_cancel | ( | void |  | ) |

Try to cancel data which may still be in the device's buffers.

unsigned audio_output_all_check | ( | void |  | ) |

Checks if the output devices have drained their music pipe, and returns the consumed music chunks to the #music_buffer.

Returns:
  the number of chunks to play left in the #music_pipe

void audio_output_all_close | ( | void |  | ) |

Closes all audio outputs.

void audio_output_all_drain | ( | void |  | ) |

Drain all audio outputs.

void audio_output_all_enable_disable | ( | void |  | ) |

Checks the "enabled" flag of all audio outputs, and if one has changed, commit the change.

void audio_output_all_finish | ( | void |  | ) |

Global finalization: free memory occupied by audio outputs.

All

float audio_output_all_get_elapsed_time | ( | void |  | ) |

Returns the "elapsed_time" stamp of the most recently finished chunk.

A negative value is returned when no chunk has been finished yet.

void audio_output_all_init | ( | void |  | ) |

Global initialization: load audio outputs from the configuration file and initialize them.

bool audio_output_all_open | ( | const struct audio_format * | audio_format,
|  | struct music_buffer * | buffer
| ) |  |

Opens all audio outputs which are not disabled.

Parameters:

  audio_format | the preferred audio format, or NULL to reuse the previous format
  buffer | the #music_buffer where consumed music_chunk objects should be returned

Returns:
  true on success, false on failure

void audio_output_all_pause | ( | void |  | ) |

Puts all audio outputs into pause mode.

Most implementations will simply close it then.

bool audio_output_all_play | ( | struct music_chunk * | chunk | ) |

Enqueue a music_chunk object for playing, i.e.

pushes it to a #music_pipe.

Parameters:

  chunk | the music_chunk object to be played

Returns:
  true on success, false if no audio output was able to play (all closed then)

void audio_output_all_release | ( | void |  | ) |

Closes all audio outputs.

Outputs with the "always_on" flag are put into pause mode.

void audio_output_all_song_border | ( | void |  | ) |

Indicate that a new song will begin now.

bool audio_output_all_wait | ( | unsigned | threshold | ) |

Checks if the size of the #music_pipe is below the #threshold.

If not, it attempts to synchronize with all output threads, and waits until another music_chunk is finished.

Parameters:

  threshold | the maximum number of chunks in the pipe

Returns:
  true if there are less than #threshold chunks in the pipe

unsigned int audio_output_count | ( | void |  | ) |

Returns the total number of audio output devices, including those who are disabled right now.

struct audio_output* audio_output_find | ( | const char * | name | ) | `[read]`

Returns the audio output device with the specified name.

Returns NULL if the name does not exist.

struct audio_output* audio_output_get | ( | unsigned | i | ) | `[read]`

Returns the "i"th audio output device.